<template>
    <div>
        <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
            <p>{{ error }}</p>
        </base-dialog>
        <section>
            <base-card>
                <div class="controls">
                    <base-button v-if="!isLoggedIn" link to="/auth/login">Login to create new article
                    </base-button>
                    <base-button v-if="isLoggedIn  && !isLoading" link to="/articles/create">create new
                        article
                    </base-button>
                </div>
                <div v-if="isLoading">
                    <base-spinner></base-spinner>
                </div>
                <ul v-else-if="hasArticles">
                    <article-item
                        v-for="article in articles"
                        :key="article.id"
                        :article="article"
                        :view-action="true"
                        @delete-article="deleteArticle"
                    ></article-item>
                </ul>
                <h3 v-else>No articles found.</h3>
            </base-card>
        </section>
    </div>
</template>

<script>
import ArticleItem from '../../components/articles/ArticleItem.vue';

export default {
    components: {
      ArticleItem,
    },
    data() {
        return {
            isLoading: false,
            error: null,
        };
    },
    computed: {
        isLoggedIn() {
            return this.$store.getters.isAuthenticated;
        },
        articles() {
            return this.$store.getters['articles/articles'];
        },
        hasArticles() {
            return !this.isLoading && this.$store.getters['articles/hasArticles'];
        },
    },
    created() {
        this.loadArticles();
    },
    methods: {
        async loadArticles() {
            this.isLoading = true;
            try {
                await this.$store.dispatch('articles/loadArticles');
            } catch (error) {
                this.error = error.message || 'Something went wrong!';
            }
            this.isLoading = false;
        },
        handleError() {
            this.error = null;
        },
    },
};
</script>

<style scoped>
ul {
    list-style: none;
    margin: 0;
    padding: 0;
}

.controls {
    display: flex;
    justify-content: center;
}
</style>
